################################################################################################
#
# Gauntlet
#
################################################################################################

scoreboard objectives add rc minecraft.used:minecraft.carrot_on_a_stick
scoreboard objectives add dmg_taken minecraft.custom:minecraft.damage_taken
scoreboard objectives add ability_select dummy
scoreboard objectives add x_start_rot dummy
scoreboard objectives add y_start_rot dummy
scoreboard objectives add x_rot dummy
scoreboard objectives add y_rot dummy
scoreboard objectives add select_goal dummy
scoreboard objectives add x_diff dummy
scoreboard objectives add y_diff dummy
scoreboard objectives add active_ability dummy
scoreboard objectives add portal_timer dummy
scoreboard objectives add in_control dummy
scoreboard objectives add mind_cd dummy
scoreboard objectives add g_offhand dummy
scoreboard objectives add charge dummy
scoreboard objectives add smash_timer dummy
scoreboard objectives add rocket_cd dummy
scoreboard objectives add rocket_lt dummy
scoreboard objectives add ball_count dummy
scoreboard objectives add ball_reload dummy
scoreboard objectives add freeze_timer dummy
scoreboard objectives add invisible dummy
scoreboard objectives add trap_count dummy
scoreboard objectives add select_last dummy
scoreboard objectives add select_diff dummy
scoreboard objectives add freeze_sound dummy
scoreboard objectives add ET dummy
scoreboard objectives add sneak minecraft.custom:minecraft.sneak_time

# Resistance while mind control and rocket launcher

function gauntlet:entitytype

team add nocoll
team empty nocoll
team join nocoll @a
team option nocoll seeFriendlyInvisibles false
team option nocoll collisionRule never


scoreboard players add @a ability_select 0
scoreboard players add @a in_control 0
scoreboard players add @a rocket_cd 0

########################################################## Crafting #########################################################

execute at @e[nbt={Item:{id:"minecraft:nether_star",Count:1b},OnGround:1b}] run execute at @e[nbt={Item:{id:"minecraft:orange_dye",Count:1b},OnGround:1b},distance=..1] run summon area_effect_cloud ~ ~ ~ {Tags:["stone1","stone"],Duration:1}
execute at @e[nbt={Item:{id:"minecraft:nether_star",Count:1b},OnGround:1b}] run execute at @e[nbt={Item:{id:"minecraft:dandelion_yellow",Count:1b},OnGround:1b},distance=..1] run summon area_effect_cloud ~ ~ ~ {Tags:["stone2","stone"],Duration:1}
execute at @e[nbt={Item:{id:"minecraft:nether_star",Count:1b},OnGround:1b}] run execute at @e[nbt={Item:{id:"minecraft:lapis_lazuli",Count:1b},OnGround:1b},distance=..1] run summon area_effect_cloud ~ ~ ~ {Tags:["stone3","stone"],Duration:1}
execute at @e[nbt={Item:{id:"minecraft:nether_star",Count:1b},OnGround:1b}] run execute at @e[nbt={Item:{id:"minecraft:cactus_green",Count:1b},OnGround:1b},distance=..1] run summon area_effect_cloud ~ ~ ~ {Tags:["stone4","stone"],Duration:1}
execute at @e[nbt={Item:{id:"minecraft:nether_star",Count:1b},OnGround:1b}] run execute at @e[nbt={Item:{id:"minecraft:rose_red",Count:1b},OnGround:1b},distance=..1] run summon area_effect_cloud ~ ~ ~ {Tags:["stone5","stone"],Duration:1}
execute at @e[nbt={Item:{id:"minecraft:nether_star",Count:1b},OnGround:1b}] run execute at @e[nbt={Item:{id:"minecraft:purple_dye",Count:1b},OnGround:1b},distance=..1] run summon area_effect_cloud ~ ~ ~ {Tags:["stone6","stone"],Duration:1}


execute at @e[tag=stone1] run summon item ~ ~ ~ {Item:{id:"minecraft:diamond_pickaxe",Count:1,tag:{Damage:9s,Unbreakable:1,display:{Name:"{\"text\":\"§6Infinity Stone\"}"},HideFlags:63}}}
execute at @e[tag=stone2] run summon item ~ ~ ~ {Item:{id:"minecraft:diamond_pickaxe",Count:1,tag:{Damage:10s,Unbreakable:1,display:{Name:"{\"text\":\"§eInfinity Stone\"}"},HideFlags:63}}}
execute at @e[tag=stone3] run summon item ~ ~ ~ {Item:{id:"minecraft:diamond_pickaxe",Count:1,tag:{Damage:11s,Unbreakable:1,display:{Name:"{\"text\":\"§9Infinity Stone\"}"},HideFlags:63}}}
execute at @e[tag=stone4] run summon item ~ ~ ~ {Item:{id:"minecraft:diamond_pickaxe",Count:1,tag:{Damage:12s,Unbreakable:1,display:{Name:"{\"text\":\"§2Infinity Stone\"}"},HideFlags:63}}}
execute at @e[tag=stone5] run summon item ~ ~ ~ {Item:{id:"minecraft:diamond_pickaxe",Count:1,tag:{Damage:13s,Unbreakable:1,display:{Name:"{\"text\":\"§4Infinity Stone\"}"},HideFlags:63}}}
execute at @e[tag=stone6] run summon item ~ ~ ~ {Item:{id:"minecraft:diamond_pickaxe",Count:1,tag:{Damage:14s,Unbreakable:1,display:{Name:"{\"text\":\"§5Infinity Stone\"}"},HideFlags:63}}}
execute at @e[tag=stone1] run kill @e[nbt={Item:{id:"minecraft:orange_dye",Count:1b}},distance=..2]
execute at @e[tag=stone2] run kill @e[nbt={Item:{id:"minecraft:dandelion_yellow",Count:1b}},distance=..2]
execute at @e[tag=stone3] run kill @e[nbt={Item:{id:"minecraft:lapis_lazuli",Count:1b}},distance=..2]
execute at @e[tag=stone4] run kill @e[nbt={Item:{id:"minecraft:cactus_green",Count:1b}},distance=..2]
execute at @e[tag=stone5] run kill @e[nbt={Item:{id:"minecraft:rose_red",Count:1b}},distance=..2]
execute at @e[tag=stone6] run kill @e[nbt={Item:{id:"minecraft:purple_dye",Count:1b}},distance=..2]
execute at @e[tag=stone] run kill @e[nbt={Item:{id:"minecraft:nether_star",Count:1b}},distance=..2]
execute at @e[tag=stone] run playsound minecraft:entity.firework.twinkle master @a
execute at @e[tag=stone] run particle firework ~ ~0.15 ~ 0 0 0 0.1 8

execute at @e[nbt={Item:{id:"minecraft:ender_eye",Count:1b},OnGround:1b}] run execute at @e[nbt={Item:{id:"minecraft:gold_ingot",Count:64b},OnGround:1b},distance=..1] run execute at @e[nbt={Item:{id:"minecraft:diamond_pickaxe",Count:1b,tag:{Damage:9}},OnGround:1b},distance=..1] run execute at @e[nbt={Item:{id:"minecraft:diamond_pickaxe",Count:1b,tag:{Damage:10}},OnGround:1b},distance=..1] run execute at @e[nbt={Item:{id:"minecraft:diamond_pickaxe",Count:1b,tag:{Damage:11}},OnGround:1b},distance=..1] run execute at @e[nbt={Item:{id:"minecraft:diamond_pickaxe",Count:1b,tag:{Damage:12}},OnGround:1b},distance=..1] run execute at @e[nbt={Item:{id:"minecraft:diamond_pickaxe",Count:1b,tag:{Damage:13}},OnGround:1b},distance=..1] run execute at @e[nbt={Item:{id:"minecraft:diamond_pickaxe",Count:1b,tag:{Damage:14}},OnGround:1b},distance=..1] run summon area_effect_cloud ~ ~ ~ {Tags:["g_spawn"],Duration:1}

execute at @e[tag=g_spawn] run playsound minecraft:entity.firework.twinkle_far master @a
execute at @e[tag=g_spawn] run kill @e[type=item,distance=..2]
execute at @e[tag=g_spawn] run summon item ~ ~ ~ {Item:{id:"minecraft:carrot_on_a_stick",Count:1,tag:{Unbreakable:1,display:{Name:"{\"text\":\"§6Infinity Gauntlet\"}"},HideFlags:63}}}
execute at @e[tag=g_spawn] run particle firework ~ ~0.15 ~ 0 0 0 0.1 10
execute at @e[tag=g_spawn] run particle enchant ~ ~0.15 ~ 0 0 0 0.2 10


################################################### Ability Selection #####################################################

scoreboard players operation @a select_last = @a select_goal

scoreboard players set @a g_offhand 0
scoreboard players set @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:carrot_on_a_stick",Count:1b,tag:{Unbreakable:1,Damage:0}}]}] g_offhand 1

scoreboard players add @a[scores={g_offhand=1..,ability_select=..9}] ability_select 1
scoreboard players set @a[scores={g_offhand=1..,ability_select=..-1}] ability_select 1


scoreboard players set @a[scores={g_offhand=0,ability_select=1..}] ability_select 0
scoreboard players remove @a[scores={g_offhand=0,ability_select=-9..}] ability_select 1


effect give @a[scores={ability_select=1..}] levitation 1 255 true
effect give @a[scores={ability_select=1..}] resistance 1 250 true

effect clear @a[scores={ability_select=-2}] levitation
effect clear @a[scores={ability_select=-2}] resistance

execute as @a[scores={ability_select=1}] at @s run playsound click2 master @p
execute as @a[scores={ability_select=-1}] at @s run playsound click3 master @p
execute as @a[scores={ability_select=1}] at @s run summon armor_stand ~ ~ ~ {Tags:[wheel_pos],Invisible:1,NoGravity:1}
execute as @a[scores={ability_select=1}] at @s run summon armor_stand ~ ~ ~ {Tags:[wheel],Pose:{Head:[1f,1f,1f]},Invisible:1,NoGravity:1}
execute as @a[scores={ability_select=-1}] at @s run kill @e[tag=wheel,limit=1,sort=nearest]
execute as @a[scores={ability_select=-1}] at @s run kill @e[tag=wheel_pos,limit=1,sort=nearest]
execute as @a[scores={ability_select=2}] at @s run tp @e[tag=wheel,limit=1,sort=nearest] ^ ^ ^1
execute as @a[scores={ability_select=2}] at @s run execute as @e[tag=wheel,limit=1,sort=nearest] run execute store result entity @s Rotation[0] float 1 run data get entity @p[scores={ability_select=2}] Rotation[0] 1
execute as @a[scores={ability_select=2}] at @s run execute as @e[tag=wheel,limit=1,sort=nearest] run execute store result entity @s Pose.Head[0] float 1 run data get entity @p[scores={ability_select=2}] Rotation[1] 1

execute at @e[tag=wheel_pos] run tp @p[scores={ability_select=1..}] ~ ~ ~

execute as @a[scores={ability_select=1}] run execute store result score @s x_start_rot run data get entity @s Rotation[0] -1
execute as @a[scores={ability_select=1}] run execute store result score @s y_start_rot run data get entity @s Rotation[1] 1
execute as @a[scores={ability_select=1..}] run execute store result score @s x_rot run data get entity @s Rotation[0] -1
execute as @a[scores={ability_select=1..}] run execute store result score @s y_rot run data get entity @s Rotation[1] 1

execute as @a[scores={ability_select=1..}] run scoreboard players operation @s x_diff = @s x_start_rot
execute as @a[scores={ability_select=1..}] run scoreboard players operation @s x_diff -= @s x_rot
execute as @a[scores={x_diff=..-180}] run scoreboard players add @s x_diff 360
execute as @a[scores={x_diff=180..}] run scoreboard players remove @s x_diff 360

execute as @a[scores={ability_select=1..}] run scoreboard players operation @s y_diff = @s y_start_rot
execute as @a[scores={ability_select=1..}] run scoreboard players operation @s y_diff -= @s y_rot

scoreboard players set @a select_goal 0
scoreboard players set @a[scores={x_diff=..-7,y_diff=-5..5}] select_goal 1
scoreboard players set @a[scores={x_diff=..-6,y_diff=6..}] select_goal 2
scoreboard players set @a[scores={x_diff=-5..5,y_diff=7..}] select_goal 3
scoreboard players set @a[scores={x_diff=6..,y_diff=6..}] select_goal 4
scoreboard players set @a[scores={x_diff=7..,y_diff=-5..5}] select_goal 5
scoreboard players set @a[scores={x_diff=6..,y_diff=..-6}] select_goal 6
scoreboard players set @a[scores={x_diff=-5..5,y_diff=..-7}] select_goal 7
scoreboard players set @a[scores={x_diff=..-6,y_diff=..-6}] select_goal 8


execute as @a[scores={select_goal=0,ability_select=5..}] at @s run data merge entity @e[tag=wheel,limit=1,sort=nearest] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:0},Count:1}]}
execute as @a[scores={select_goal=1,ability_select=5..}] at @s run data merge entity @e[tag=wheel,limit=1,sort=nearest] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:1},Count:1}]}
execute as @a[scores={select_goal=2,ability_select=5..}] at @s run data merge entity @e[tag=wheel,limit=1,sort=nearest] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:2},Count:1}]}
execute as @a[scores={select_goal=3,ability_select=5..}] at @s run data merge entity @e[tag=wheel,limit=1,sort=nearest] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:3},Count:1}]}
execute as @a[scores={select_goal=4,ability_select=5..}] at @s run data merge entity @e[tag=wheel,limit=1,sort=nearest] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:4},Count:1}]}
execute as @a[scores={select_goal=5,ability_select=5..}] at @s run data merge entity @e[tag=wheel,limit=1,sort=nearest] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:5},Count:1}]}
execute as @a[scores={select_goal=6,ability_select=5..}] at @s run data merge entity @e[tag=wheel,limit=1,sort=nearest] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:6},Count:1}]}
execute as @a[scores={select_goal=7,ability_select=5..}] at @s run data merge entity @e[tag=wheel,limit=1,sort=nearest] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:7},Count:1}]}
execute as @a[scores={select_goal=8,ability_select=5..}] at @s run data merge entity @e[tag=wheel,limit=1,sort=nearest] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:8},Count:1}]}



scoreboard players add @a active_ability 0
scoreboard players set @a[scores={select_goal=1,ability_select=-2}] active_ability 1
scoreboard players set @a[scores={select_goal=2,ability_select=-2}] active_ability 2
scoreboard players set @a[scores={select_goal=3,ability_select=-2}] active_ability 3
scoreboard players set @a[scores={select_goal=4,ability_select=-2}] active_ability 4
scoreboard players set @a[scores={select_goal=5,ability_select=-2}] active_ability 5
scoreboard players set @a[scores={select_goal=6,ability_select=-2}] active_ability 6
scoreboard players set @a[scores={select_goal=7,ability_select=-2}] active_ability 7
scoreboard players set @a[scores={select_goal=8,ability_select=-2}] active_ability 8
execute as @a[scores={ability_select=-2,select_goal=1..8}] at @s run playsound bling1 master @p
execute as @a[scores={ability_select=-2,select_goal=0}] at @s run playsound bling2 master @p


scoreboard players operation @a select_diff = @a select_goal
scoreboard players operation @a select_diff -= @a select_last

execute as @a[scores={select_diff=..-1}] at @s run playsound click1 master @p
execute as @a[scores={select_diff=1..}] at @s run playsound click1 master @p













################################################################## Ability 6 - Invisibility ##############################################################################

scoreboard players add @a invisible 0

clear @a[scores={active_ability=6,rc=1..}] carrot_on_a_stick
execute at @a[scores={active_ability=6,rc=1..}] run playsound invis master @a ~ ~ ~ 100000.0 1
effect give @a[scores={active_ability=6,rc=1..}] invisibility 999999 9 true
effect give @a[scores={active_ability=6,rc=1..}] speed 999999 4 true
execute as @a[scores={active_ability=6,invisible=1}] at @s run team join nocoll @e[scores={ET=1..}]
scoreboard players set @a[scores={active_ability=6,rc=1..}] invisible 1

replaceitem entity @a[scores={sneak=1,active_ability=6,invisible=1}] hotbar.0 carrot_on_a_stick{HideFlags:63,Damage:0,Unbreakable:1,display:{Name:"{\"text\":\"§6Infinity Gauntlet\"}"}}
effect clear @a[scores={sneak=1,active_ability=6,invisible=1}] speed
effect clear @a[scores={sneak=1,active_ability=6,invisible=1}] invisibility
scoreboard players set @a[scores={active_ability=6,sneak=1..,invisible=1}] invisible 0



################################################################## Ability 8 - Trap ##############################################################################
scoreboard players set @a trap_count 0
execute as @e[tag=trap] run scoreboard players add @a trap_count 1

execute as @a[scores={active_ability=8,rc=1,trap_count=..4}] at @s run playsound trap1 master @a ~ ~ ~ 100000.0 1
execute as @a[scores={active_ability=8,rc=1,trap_count=..4}] at @s run summon area_effect_cloud ~ ~ ~ {Duration:999999999,Tags:[trap]} 
execute at @e[tag=trap] run particle portal ~ ~ ~ 0 0 0 3 4 force
execute at @e[tag=trap] run particle mycelium ~ ~ ~ 2 2 2 0.1 1 force
execute at @e[tag=trap] run particle smoke ~ ~0.3 ~ 0.1 0.4 0.1 0.05 1 force
execute as @e[tag=trap] at @s run tp @e[scores={ET=1..},distance=..7] @s
execute as @e[tag=trap] at @s run kill @e[tag=trap,distance=0.1..7]


execute as @a[scores={active_ability=8,sneak=1..}] at @s run execute at @e[tag=trap,limit=1] run playsound trap2 master @a ~ ~ ~ 100000.0 1
execute as @a[scores={active_ability=8,sneak=1..}] at @s run execute at @e[tag=trap] run tp @e[scores={ET=1..},distance=..2] @p[scores={active_ability=8,sneak=1..}]
execute as @a[scores={active_ability=8,sneak=1..}] at @s run kill @e[tag=trap]







################################################################## Ability 7  - Time freeze motion 0 0 0 ##############################################################################

scoreboard players remove @a freeze_timer 1
scoreboard players set @a[scores={freeze_timer=..0}] freeze_sound -1
scoreboard players add @a freeze_sound 1

scoreboard players set @a[scores={active_ability=7,rc=1..}] freeze_timer 10


execute at @a[scores={active_ability=7,freeze_sound=2}] run playsound slow_in master @a ~ ~ ~ 10000.0 
execute at @a[scores={active_ability=7,freeze_timer=-1}] run playsound slow_out master @a ~ ~ ~ 10000.0 

execute as @a[scores={active_ability=7,freeze_timer=1..}] at @s run particle mycelium ~ ~ ~ 4 2 4 0.01 3 force
execute as @a[scores={active_ability=7,freeze_timer=1..}] at @s run particle enchant ~ ~ ~ 4 2 4 0.01 5 force
execute as @a[scores={active_ability=7,freeze_timer=1..}] at @s run execute as @e[scores={ET=1..},distance=..200] run data merge entity @s {Motion:[0.0,0.0,0.0],NoAI:1}
execute as @a[scores={active_ability=7,freeze_timer=0}] at @s run execute as @e[scores={ET=1..},distance=..300] run data merge entity @s {NoAI:0}



################################################################## Ability 5 - Rotating fireball thing ##############################################################################


scoreboard players add @a ball_reload 1
scoreboard players add @a ball_count 0

execute at @a[scores={active_ability=5,ball_reload=80..,ball_count=0..4},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick"}]}] run playsound firespawn master @a ~ ~ ~ 10000.0 1
execute at @a[scores={active_ability=5,ball_reload=80..,ball_count=0},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick"}]}] run summon armor_stand ~ ~ ~ {Tags:["ball1_c","ball","b1"],NoGravity:1,Marker:1,Invisible:1}
execute at @a[scores={active_ability=5,ball_reload=80..,ball_count=0},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick"}]}] run summon armor_stand ~ ~ ~ {Tags:["ball1","ball","b1","ball_f"],NoGravity:1,Marker:1,Invisible:1}
execute at @a[scores={active_ability=5,ball_reload=80..,ball_count=1},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick"}]}] run summon armor_stand ~ ~ ~ {Tags:["ball2_c","ball","b2"],NoGravity:1,Marker:1,Invisible:1}
execute at @a[scores={active_ability=5,ball_reload=80..,ball_count=1},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick"}]}] run summon armor_stand ~ ~ ~ {Tags:["ball2","ball","b2","ball_f"],NoGravity:1,Marker:1,Invisible:1}
execute at @a[scores={active_ability=5,ball_reload=80..,ball_count=2},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick"}]}] run summon armor_stand ~ ~ ~ {Tags:["ball3_c","ball","b3"],NoGravity:1,Marker:1,Invisible:1}
execute at @a[scores={active_ability=5,ball_reload=80..,ball_count=2},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick"}]}] run summon armor_stand ~ ~ ~ {Tags:["ball3","ball","b3","ball_f"],NoGravity:1,Marker:1,Invisible:1}
execute at @a[scores={active_ability=5,ball_reload=80..,ball_count=3},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick"}]}] run summon armor_stand ~ ~ ~ {Tags:["ball4_c","ball","b4"],NoGravity:1,Marker:1,Invisible:1}
execute at @a[scores={active_ability=5,ball_reload=80..,ball_count=3},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick"}]}] run summon armor_stand ~ ~ ~ {Tags:["ball4","ball","b4","ball_f"],NoGravity:1,Marker:1,Invisible:1}
execute at @a[scores={active_ability=5,ball_reload=80..,ball_count=4},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick"}]}] run summon armor_stand ~ ~ ~ {Tags:["ball5_c","ball","b5"],NoGravity:1,Marker:1,Invisible:1}
execute at @a[scores={active_ability=5,ball_reload=80..,ball_count=4},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick"}]}] run summon armor_stand ~ ~ ~ {Tags:["ball5","ball","b5","ball_f"],NoGravity:1,Marker:1,Invisible:1}

scoreboard players add @a[scores={active_ability=5,ball_reload=80..,ball_count=..4}] ball_count 1
scoreboard players set @a[scores={active_ability=5,ball_reload=80..}] ball_reload 0


execute at @a[scores={active_ability=5}] run tp @e[tag=ball1_c,limit=1,sort=nearest] ~ ~ ~
execute at @a[scores={active_ability=5}] run tp @e[tag=ball2_c,limit=1,sort=nearest] ~ ~ ~
execute at @a[scores={active_ability=5}] run tp @e[tag=ball3_c,limit=1,sort=nearest] ~ ~ ~
execute at @a[scores={active_ability=5}] run tp @e[tag=ball4_c,limit=1,sort=nearest] ~ ~ ~
execute at @a[scores={active_ability=5}] run tp @e[tag=ball5_c,limit=1,sort=nearest] ~ ~ ~
execute as @e[tag=ball1_c] at @s run tp @s ~ ~ ~ ~9 ~
execute as @e[tag=ball2_c] at @s run tp @s ~ ~ ~ ~6 ~
execute as @e[tag=ball3_c] at @s run tp @s ~ ~ ~ ~12 ~
execute as @e[tag=ball4_c] at @s run tp @s ~ ~ ~ ~6 ~
execute as @e[tag=ball5_c] at @s run tp @s ~ ~ ~ ~7 ~
execute as @a[scores={active_ability=5}] at @s run execute at @e[tag=ball1_c,limit=1,sort=nearest] run tp @e[tag=ball1,tag=!shot] ^ ^0.5 ^3
execute as @a[scores={active_ability=5}] at @s run execute at @e[tag=ball2_c,limit=1,sort=nearest] run tp @e[tag=ball2,tag=!shot] ^ ^0.8 ^3.4
execute as @a[scores={active_ability=5}] at @s run execute at @e[tag=ball3_c,limit=1,sort=nearest] run tp @e[tag=ball3,tag=!shot] ^ ^1.5 ^1.9
execute as @a[scores={active_ability=5}] at @s run execute at @e[tag=ball4_c,limit=1,sort=nearest] run tp @e[tag=ball4,tag=!shot] ^ ^0.2 ^2.4
execute as @a[scores={active_ability=5}] at @s run execute at @e[tag=ball5_c,limit=1,sort=nearest] run tp @e[tag=ball5,tag=!shot] ^ ^1.2 ^4.2



execute as @a[scores={active_ability=5,rc=1..,ball_count=1..5}] at @s run playsound fireshoot master @a ~ ~ ~ 10000.0 1
execute as @a[scores={active_ability=5,rc=1..,ball_count=1}] at @s run kill @e[tag=ball1_c]
execute as @a[scores={active_ability=5,rc=1..,ball_count=2}] at @s run kill @e[tag=ball2_c]
execute as @a[scores={active_ability=5,rc=1..,ball_count=3}] at @s run kill @e[tag=ball3_c]
execute as @a[scores={active_ability=5,rc=1..,ball_count=4}] at @s run kill @e[tag=ball4_c]
execute as @a[scores={active_ability=5,rc=1..,ball_count=5}] at @s run kill @e[tag=ball5_c]
execute as @a[scores={active_ability=5,rc=1..,ball_count=1}] at @s run tag @e[tag=ball1] add shot
execute as @a[scores={active_ability=5,rc=1..,ball_count=2}] at @s run tag @e[tag=ball2] add shot
execute as @a[scores={active_ability=5,rc=1..,ball_count=3}] at @s run tag @e[tag=ball3] add shot
execute as @a[scores={active_ability=5,rc=1..,ball_count=4}] at @s run tag @e[tag=ball4] add shot
execute as @a[scores={active_ability=5,rc=1..,ball_count=5}] at @s run tag @e[tag=ball5] add shot
#execute as @a[scores={active_ability=5,rc=1..,ball_count=1}] at @s run tag @e[tag=b1] remove b1
#execute as @a[scores={active_ability=5,rc=1..,ball_count=2}] at @s run tag @e[tag=b2] remove b2
#execute as @a[scores={active_ability=5,rc=1..,ball_count=3}] at @s run tag @e[tag=b3] remove b3
#execute as @a[scores={active_ability=5,rc=1..,ball_count=4}] at @s run tag @e[tag=b4] remove b4
#execute as @a[scores={active_ability=5,rc=1..,ball_count=5}] at @s run tag @e[tag=b5] remove b5

scoreboard players remove @a[scores={active_ability=5,rc=1..,ball_count=1..}] ball_count 1


execute at @e[tag=ball_f] run particle smoke ~ ~ ~ 0 0 0 0.02 2 force
execute at @e[tag=ball_f] run particle flame ~ ~ ~ 0 0 0 0.02 4 force

execute as @e[tag=shot] at @s run tp @s ^ ^ ^0.6 facing entity @e[scores={ET=1..},sort=nearest,limit=1]
execute as @e[tag=shot] at @s run effect give @e[scores={ET=2},distance=..1] instant_health 1 2 true
execute as @e[tag=shot] at @s run effect give @e[scores={ET=1},distance=..1] instant_damage 1 2 true
execute as @e[tag=shot] at @s run execute at @e[scores={ET=1..},distance=..1] run kill @s
tag @e[tag=shot] add shot_kill
execute at @e[scores={ET=1..}] run tag @e[tag=shot_kill,distance=..50] remove shot_kill
kill @e[tag=shot_kill]



execute as @a[scores={active_ability=..4}] at @s run kill @e[tag=ball]
execute as @a[scores={active_ability=6..}] at @s run kill @e[tag=ball]
scoreboard players set @a[scores={active_ability=..4}] ball_count 0
scoreboard players set @a[scores={active_ability=6..}] ball_count 0


################################################################## Ability 1 - Portal ##############################################################################

scoreboard players add @a portal_timer 0
execute as @a[scores={active_ability=1,rc=1..,portal_timer=..0}] at @s run scoreboard players set @s portal_timer 1

scoreboard players add @a[scores={portal_timer=1..}] portal_timer 1
scoreboard players set @a[scores={portal_timer=50..}] portal_timer 0

execute as @a[scores={portal_timer=2}] at @s run playsound openportal master @a ~ ~ ~ 10000.0 1
execute as @a[scores={portal_timer=2}] at @s run summon armor_stand ~ ~ ~ {Tags:["portal","portal1","portal1_init"],NoGravity:1,Invisible:1}
execute as @a[scores={portal_timer=2}] at @s run summon armor_stand ~ ~ ~ {Tags:["portal","portal2","portal2_init"],NoGravity:1,Invisible:1}
execute as @a[scores={portal_timer=2}] at @s run tp @e[tag=portal,limit=2,sort=nearest] @s
execute as @a[scores={portal_timer=2}] at @s run tp @e[tag=portal,limit=2,sort=nearest] ~ ~ ~ ~ 0
execute as @a[scores={portal_timer=2}] at @s run execute as @e[tag=portal1_init,limit=1,sort=nearest] at @s run tp @s ^ ^10 ^3
execute as @a[scores={portal_timer=2}] at @s run execute as @e[tag=portal2_init,limit=1,sort=nearest] at @s run tp @s ^ ^10 ^17
execute as @a[scores={portal_timer=2}] at @s run execute as @e[tag=portal1_init,limit=1,sort=nearest] at @s run function gauntlet:1_up
execute as @a[scores={portal_timer=2}] at @s run execute as @e[tag=portal2_init,limit=1,sort=nearest] at @s run function gauntlet:1_up
tag @e remove portal1_init
tag @e remove portal2_init



execute at @e[tag=portal1] run tag @a[distance=..1] add pt_tp
execute as @a[tag=pt_tp] at @s run execute at @e[tag=portal2,sort=nearest,limit=1] run playsound minecraft:entity.endermen.teleport master @a ~ ~ ~ 10000.0 1
execute as @a[tag=pt_tp] at @s run execute at @e[tag=portal2,sort=nearest,limit=1] run tp @s ~ ~ ~ 
execute as @a[tag=pt_tp] at @s run kill @e[tag=portal1,limit=1,sort=nearest]
execute as @a[tag=pt_tp] at @s run kill @e[tag=portal2,limit=1,sort=nearest]
scoreboard players set @a[tag=pt_tp] portal_timer 0
tag @a remove pt_tp
execute at @e[tag=portal] run particle smoke ~ ~0.9 ~ 0 0 0 0.1 1 force
execute at @e[tag=portal] run particle enchant ~ ~0.9 ~ 0.2 0.2 0.2 0.6 1 force
execute at @e[tag=portal] run particle portal ~ ~0.4 ~ 0 0 0 0.4 10 force
execute at @e[tag=portal] run particle portal ~ ~0.4 ~ 0.1 0.1 0.1 0.5 10 force


execute as @a[scores={portal_timer=49}] at @s run kill @e[tag=portal1,limit=1,sort=nearest]
execute as @a[scores={portal_timer=49}] at @s run kill @e[tag=portal2,limit=1,sort=nearest]

################################################################## Ability 2 - Charge/Smash ##############################################################################

execute as @a[scores={active_ability=2}] at @s run particle minecraft:enchant ~ ~1 ~ 0.1 0.2 0.1 0.5 2
execute as @a[scores={active_ability=2,dmg_taken=1..}] at @s run particle minecraft:firework ~ ~1 ~ 0 0 0 0.1 1
effect give @a[scores={active_ability=2,dmg_taken=1..}] instant_health 9 9 true
execute at @a[scores={active_ability=2,dmg_taken=1..}] run playsound absorb master @a
scoreboard players add @a[scores={active_ability=2,dmg_taken=1..}] charge 1
execute as @a[scores={active_ability=2,dmg_taken=1..}] at @s run 
execute as @a[scores={active_ability=2,dmg_taken=1..}] at @s run 


scoreboard players add @a smash_timer 0
scoreboard players add @a[scores={smash_timer=1..9}] smash_timer 1

execute at @a[scores={active_ability=2,rc=1..,smash_timer=..0}] run playsound jump master @a
scoreboard players set @a[scores={active_ability=2,rc=1..,smash_timer=..0}] smash_timer 1
execute as @a[scores={smash_timer=1,charge=0..10}] at @s run effect give @s levitation 1 15 true
execute as @a[scores={smash_timer=1,charge=11..20}] at @s run effect give @s levitation 1 22 true
execute as @a[scores={smash_timer=1,charge=21..30}] at @s run effect give @s levitation 1 29 true
execute as @a[scores={smash_timer=1,charge=31..40}] at @s run effect give @s levitation 1 35 true
execute as @a[scores={smash_timer=1,charge=41..}] at @s run effect give @s levitation 1 40 true
execute as @a[scores={smash_timer=1}] at @s run effect give @s resistance 6 240 true
execute as @a[scores={smash_timer=7}] at @s run effect clear @s levitation

execute as @a[scores={smash_timer=5..10,charge=1..10},nbt={OnGround:1b}] at @s run summon creeper ~ ~ ~ {Fuse:0,ExplosionRadius:2,DeathLootTable:"",DeathTime:19}
execute as @a[scores={smash_timer=5..10,charge=11..20},nbt={OnGround:1b}] at @s run summon creeper ~ ~ ~ {Fuse:0,ExplosionRadius:5,DeathLootTable:"",DeathTime:19}
execute as @a[scores={smash_timer=5..10,charge=21..30},nbt={OnGround:1b}] at @s run summon creeper ~ ~ ~ {Fuse:0,ExplosionRadius:9,DeathLootTable:"",DeathTime:19}
execute as @a[scores={smash_timer=5..10,charge=31..40},nbt={OnGround:1b}] at @s run summon creeper ~ ~ ~ {Fuse:0,ExplosionRadius:15,DeathLootTable:"",DeathTime:19}
execute as @a[scores={smash_timer=5..10,charge=41..},nbt={OnGround:1b}] at @s run summon creeper ~ ~ ~ {Fuse:0,ExplosionRadius:20,DeathLootTable:"",DeathTime:19}

scoreboard players set @a[scores={smash_timer=5..10},nbt={OnGround:1b}] charge 0
scoreboard players set @a[scores={smash_timer=5..10},nbt={OnGround:1b}] smash_timer 0

title @a[scores={active_ability=2,charge=0}] actionbar ["",{"text":"","color":"gold"},{"text":"⬛⬛⬛⬛⬛","color":"dark_gray"}]
title @a[scores={active_ability=2,charge=1..10}] actionbar ["",{"text":"⬛","color":"gold"},{"text":"⬛⬛⬛⬛","color":"dark_gray"}]
title @a[scores={active_ability=2,charge=11..20}] actionbar ["",{"text":"⬛⬛","color":"gold"},{"text":"⬛⬛⬛","color":"dark_gray"}]
title @a[scores={active_ability=2,charge=21..30}] actionbar ["",{"text":"⬛⬛⬛","color":"gold"},{"text":"⬛⬛","color":"dark_gray"}]
title @a[scores={active_ability=2,charge=31..40}] actionbar ["",{"text":"⬛⬛⬛⬛","color":"gold"},{"text":"⬛","color":"dark_gray"}]
title @a[scores={active_ability=2,charge=41..}] actionbar ["",{"text":"⬛⬛⬛⬛⬛","color":"gold"},{"text":"","color":"dark_gray"}]


scoreboard players set @a dmg_taken 0


################################################################## Ability 3 - Mind Control ##############################################################################

execute as @a[scores={active_ability=3,in_control=..0}] at @s positioned ^ ^ ^6 run effect clear @e[scores={ET=1..},sort=nearest,limit=1,distance=..7] glowing
execute as @a[scores={active_ability=3,in_control=..0}] at @s positioned ^ ^ ^6 run effect give @e[scores={ET=1..},sort=nearest,limit=1,distance=..5] glowing 1 1 true

scoreboard players add @a mind_cd 0
scoreboard players remove @a[scores={mind_cd=1..}] mind_cd 1
scoreboard players set @a[scores={in_control=1..}] mind_cd 20
scoreboard players add @a in_control 0
execute as @a[scores={active_ability=3,rc=1..,in_control=..0,mind_cd=..0}] at @s positioned ^ ^ ^6 run tag @e[scores={ET=1..},distance=..5,limit=1,sort=nearest] add controlled
team join nocoll @e[tag=controlled]

execute as @a[scores={active_ability=3,rc=1..,in_control=..0,mind_cd=..0}] at @s run execute as @e[tag=controlled] run effect give @a[scores={active_ability=3,rc=1..,in_control=..0,mind_cd=..0}] resistance 99999 99 true
execute as @a[scores={active_ability=3,rc=1..,in_control=..0,mind_cd=..0}] at @s run execute as @e[tag=controlled] run playsound mind master @a ~ ~ ~ 10000.0 1
execute as @a[scores={active_ability=3,rc=1..,in_control=..0,mind_cd=..0}] at @s run execute as @e[tag=controlled] run summon armor_stand ~ ~ ~ {Tags:[control_pos],NoGravity:1,Invisible:1}
execute as @a[scores={active_ability=3,rc=1..,in_control=..0,mind_cd=..0}] at @s run execute at @e[tag=controlled] run tp @s ~ ~ ~
execute as @a[scores={active_ability=3,rc=1..,in_control=..0,mind_cd=..0}] at @s run effect clear @e[tag=controlled] glowing
execute at @e[tag=controlled] run clear @a[scores={active_ability=3,rc=1..,in_control=..0,mind_cd=..0}] carrot_on_a_stick
execute as @a[scores={active_ability=3,rc=1..,in_control=..0,mind_cd=..0}] at @s run execute at @e[tag=controlled] run scoreboard players set @s in_control 1



execute as @a[scores={sneak=1,in_control=1..,mind_cd=20}] at @s run execute at @e[tag=control_pos,limit=1,sort=nearest] run tp @s ~ ~ ~ 
execute as @a[scores={sneak=1,in_control=1..,mind_cd=20}] at @s run kill @e[tag=control_pos]
replaceitem entity @a[scores={sneak=1,in_control=1..,mind_cd=20}] hotbar.0 carrot_on_a_stick{HideFlags:63,Damage:0,Unbreakable:1,display:{Name:"{\"text\":\"§6Infinity Gauntlet\"}"}}
effect clear @a[scores={sneak=1,in_control=1..,mind_cd=20}] resistance
effect clear @a[scores={sneak=1,in_control=1..,mind_cd=20}] invisibility
execute at @a[scores={sneak=1,in_control=1..,mind_cd=20}] run tag @e remove controlled
scoreboard players set @a[scores={sneak=1,in_control=1..,mind_cd=20}] in_control 0

execute as @a[scores={active_ability=3,in_control=1,mind_cd=20}] at @s run tp @e[tag=controlled] @s
effect give @a[scores={active_ability=3,in_control=1,mind_cd=20}] invisibility 1 1 true










################################################################## Ability 4 - Rockets ##############################################################################

effect give @a[scores={rc=1..,rocket_cd=..0,active_ability=4}] resistance 2 99 true
execute at @a[scores={rc=1..,rocket_cd=..0,active_ability=4}] run playsound rocketfire master @a
scoreboard players set @a[scores={rc=1..,rocket_cd=..0,active_ability=4}] rocket_cd 1

execute as @a[scores={rocket_cd=1..}] at @s run function gauntlet:rocket

execute as @e[tag=rocket] at @s run function gauntlet:rocket_proj






scoreboard players set @a sneak 0
scoreboard players set @a jump 0
scoreboard players set @a walk 0
scoreboard players set @a sprint 0
scoreboard players set @a rc 0
